   PROGRAM
!---------------------------------------------------------------------------
! Written by Jim Morgan, Mitten Software, Copyright 2010 All Rights reserved
! This program released to public domain under the condition that it is not resold for profit.
! October 30, 2010
!
!This program will take the typical SQL statement generated by a Clarion Browse and fix it so it can be run from the Query Analyzer.
!
!Recommended use: Add the exe to the External Tools in SQL Mgmt Studio or run as a shortcut. Note: when you invoke the program from Mgmt Studio
!All modified query windows will be prompted with a Save Dialog. You can generally cancel the dialog and the window will stay opened.
!
!Once the program is running, leave it running. The gain focus event will prompt you to fix the clipboard.
!
!The most efficient use of the program is:
! 1) Locate the SQL statement in the SQL Profiler that you wish to rerun in Query Analzyer and put focus in the Text Area.
! 2) Press Ctrl-A (Select ALL), then Ctrl-C (Copy to ClipBoard).
! 3) Switch Focus to FixSQL.exe.
! 4) Say Yes to the prompt to fix the Clipboard.
! 5) Open a new query in Mgmt Studio.
! 6) Paste the clipboard into the query window.
!---------------------------------------------------------------------------
   MAP
Main                   PROCEDURE   !FIxes SQL Strings for Query Analyzer
   END            
   
  CODE
  Main
  RETURN

!---------------------------------------------------------------------------
Main    Procedure
!---------------------------------------------------------------------------
e_MaxLine   	   Equate(80)
e_Threshold       Equate(500)  !500 = 5 sec to avoid busy double clicks

LastTime    		LONG
CLipIn              STRING(15000)                          !
ClipOut             STRING(15000)                          !
ParmIN              CSTRING(15000)                          !

e_MaxOut            Equate(14998)    !2 less than string above

DebugOn           Byte(0)  !JM 01/02/15
InQuote     	   Byte(0)
InDblQuote   	   Byte(0)
InBracket   	   Byte(0)
InParens    	   Byte(0)

ParmQ   		      Queue,Pre(PQ)
ParmNo               BYTE
MyParm      		   CString(400)
        		      END

e_LF            Equate('<10>')
e_CR            Equate('<13>')
e_Tab           Equate('<09>')
e_LFTab         Equate('<10><09>')

SearchFor       CSTRING(15)
SearchLenLess1  Long
MaxLen          Long
ThisLen         Long

OMIT('!Bad SQL')   !------------------------ example of crap we are trying to fix.
!declare @p1 int
!set @p1=1073741834
!declare @p2 int
!set @p2=180150021
!declare @p5 int
!set @p5=1
!declare @p6 int
!set @p6=4
!declare @p7 int
!set @p7=74978
!exec sp_cursorprepexec @p1 output,@p2 output,N'@P1 char(4),@P2 char(4),@P3 datetime,@P4 datetime,@P5 char(5),@P6 char(5),@P7 varchar(9),@P8 varchar(9),@P9 smallint'
!,N'SELECT  A.ID_LOC, A.ID_SO, A.SUFX_SO, A.IDOPER, A.IDDEPT, A.IDWC, A.LOADCODE, A.DESCROPER, A.DATEENDACTUAL_DTS, A.STATRECOPER, A.IDSTN, A.PLANHRS, A.ACTHRS, A.QTYORD, A.QTYCMPL, A.PLANPCSHR, A.ACTPCSHR, A.EFF, A.PLANHRSDISP, A.ACTHRSDISP, A.EFFDISP, A.SUPAPPFLAG, A.SUPSETUPFLAG, A.SUPFLAG, A.ITEM, A.LNOTELOOK, A.SNOTELOOK, A.PRESSTDCHG, A.CUSTID, A.CUSTNAME, A.IDORD, A.PCNLOOK, A.ORDERALERT, A.PARTALERT, B.ID_SO, B.IDOPER, B.SUPOK, B.IDSUP, B.LABORREVIEW, B.LABORCLEAR, B.MEMO FROM  {oj dbo.BokVw_LABEFF_sooper2 A LEFT OUTER JOIN dbo.Suprev B ON  A.ID_SO= B.ID_SO AND  A.IDOPER= B.IDOPER }  WHERE (  A.IDDEPT = ''1000'' )
!AND  (  A.IDDEPT >= @P1 )  AND (  (  A.IDDEPT > @P2 )  OR (  (  A.DATEENDACTUAL_DTS <= @P3 )  AND (  (  A.DATEENDACTUAL_DTS < @P4 )
!OR (  (  A.ID_LOC <= @P5 )  AND (  (  A.ID_LOC < @P6 )  OR (  (  A.ID_SO <= @P7 )  AND (  (  A.ID_SO < @P8 )
!OR (  (  A.SUFX_SO <= @P9 ) )))))))) ORDER BY  A.IDDEPT,  A.DATEENDACTUAL_DTS DESC,  A.ID_LOC DESC,  A.ID_SO DESC,  A.SUFX_SO DESC'
!,@p5 output,@p6 output,@p7 output,
!'1000',
!'1000',
!'2009-11-04 00:00:00:000',
!'2009-11-04 00:00:00:000',
!'01   ',
!'01   ',
!'   633414',
!'   633414',
!0
!select @p1, @p2, @p5, @p6, @p7                                           



declare @p1 int
set @p1=1073741847
declare @p2 int
set @p2=180150063
declare @p5 int
set @p5=1
declare @p6 int
set @p6=4
declare @p7 int
set @p7=18
exec sp_cursorprepexec @p1 output,@p2 output,N'@P1 char(20),@P2 char(20),@P3 smallint,@P4 smallint,@P5 datetime,@P6 datetime,@P7 varchar(9),@P8 varchar(9),@P9 smallint',
N'SELECT  A.ID_SO, A.KSO, A.IDOPER, A.SOOPER, A.DATEDUE_DTS, A.PRIORITY, A.PLANHRS, A.ACTHRS, A.QTYORD, A.STAT_REC_OPER, A.ID_DEPT, A.ID_WC, A.ID_STN, A.OPERDESC, A.PRESSCLASS, A.KPULLTOOL, A.KASSIGN, A.KUNASSIGNED, A.KSANDRUN, A.KS1, A.KC1, A.KS2, A.KC2, A.KS3, A.KC3, A.KS4, A.KC4, A.KS5, A.KC5, A.KS6, A.KC6, A.KS7, A.KC7, A.KC9, A.KS10, A.KC10, A.KC11, A.K3000, A.K999, B.ID_SO, B.IDOPER, B.SOOPER, B.MEMO, C.PRESS, C.RSVD_CLASS, C.OUTOFACTION, C.OOANOTE, D.ID_SO, D.ID_OPER, D.PRESS, E.ID_SO, E.COPNO, E.CUSTNAME, E.IDITEMPAR, E.STATRECSO, F.ID_SO, F.IDOPER, F.DONEFLAG, F.EMPFLAG 
FROM  {oj dbo.BokVw_DISPATCH_displist1 A 
	LEFT OUTER JOIN dbo.CONSTRAINTX B ON  A.ID_SO= B.ID_SO 
	LEFT OUTER JOIN dbo.PRESSTBL C ON  A.ID_STN= C.PRESS 
	LEFT OUTER JOIN dbo.PRESS D ON  A.ID_SO= D.ID_SO AND  A.IDOPER= D.ID_OPER 
	LEFT OUTER JOIN dbo.BokVw_DISPATCH_sodtl1 E ON  A.ID_SO= E.ID_SO 
	LEFT OUTER JOIN dbo.FLAGS F ON  A.ID_SO= F.ID_SO AND  A.IDOPER= F.IDOPER }  
	WHERE (  A.KS6 <> '''' )  AND  (  A.KS6 >= @P1 )  AND (  (  A.KS6 > @P2 )  OR (  (  A.PRIORITY >= @P3 )  
	AND (  (  A.PRIORITY > @P4 )  OR (  (  A.DATEDUE_DTS >= @P5 )  
	AND (  (  A.DATEDUE_DTS > @P6 )  OR (  (  A.ID_SO >= @P7 )  
	AND (  (  A.ID_SO > @P8 )  OR (  (  A.IDOPER >= @P9 ) )))))))) 
	ORDER BY  A.KS6,  A.PRIORITY,  A.DATEDUE_DTS,  A.ID_SO,  A.IDOPER'
,@p5 output,@p6 output,@p7 output,'                    ','                    ',500,500,'2014-11-25 00:00:00','2014-11-25 00:00:00','   748773','   748773',300
select @p1, @p2, @p5, @p6, @p7



exec sp_executesql N'SELECT TOP (1) ISNULL("Customer"."timestamp",@0) AS "timestamp",ISNULL("Customer"."No_",@1) AS "No_",ISNULL("Customer"."Name",@2) AS "Name",ISNULL("Customer"."Search Name",@1) AS "Search Name",ISNULL("Customer"."Name 2",@2) AS "Name 2",ISNULL("Customer"."Address",@2) AS "Address",ISNULL("Customer"."Address 2",@2) AS "Address 2",ISNULL("Customer"."City",@2) AS "City",ISNULL("Customer"."Contact",@2) AS "Contact",ISNULL("Customer"."Phone No_",@2) AS "Phone No_",ISNULL("Customer"."Telex No_",@2) AS "Telex No_",ISNULL("Customer"."Our Account No_",@2) AS "Our Account No_",ISNULL("Customer"."Territory Code",@1) AS "Territory Code",ISNULL("Customer"."Global Dimension 1 Code",@1) AS "Global Dimension 1 Code",ISNULL("Customer"."Global Dimension 2 Code",@1) AS "Global Dimension 2 Code",ISNULL("Customer"."Chain Name",@1) AS "Chain Name",ISNULL("Customer"."Budgeted Amount",@3) AS "Budgeted Amount",ISNULL("Customer"."Credit Limit (LCY)",@3) AS "Credit Limit (LCY)",ISNULL("Customer"."Customer Posting Group",@1) AS "Customer Posting Group",ISNULL("Customer"."Currency Code",@1) AS "Currency Code",ISNULL("Customer"."Customer Price Group",@1) AS "Customer Price Group",ISNULL("Customer"."Language Code",@1) AS "Language Code",ISNULL("Customer"."Statistics Group",@4) AS "Statistics Group",ISNULL("Customer"."Payment Terms Code",@1) AS "Payment Terms Code",ISNULL("Customer"."Fin_ Charge Terms Code",@1) AS "Fin_ Charge Terms Code",ISNULL("Customer"."Salesperson Code",@1) AS "Salesperson Code",ISNULL("Customer"."Shipment Method Code",@1) AS "Shipment Method Code",ISNULL("Customer"."Shipping Agent Code",@1) AS "Shipping Agent Code",ISNULL("Customer"."Place of Export",@1) AS "Place of Export",ISNULL("Customer"."Invoice Disc_ Code",@1) AS "Invoice Disc_ Code",ISNULL("Customer"."Customer Disc_ Group",@1) AS "Customer Disc_ Group",ISNULL("Customer"."Country_Region Code",@1) AS "Country_Region Code",ISNULL("Customer"."Collection Method",@1) AS "Collection Method",ISNULL("Customer"."Amount",@3) AS "Amount",ISNULL("Customer"."Blocked",@5) AS "Blocked",ISNULL("Customer"."Invoice Copies",@4) AS "Invoice Copies",ISNULL("Customer"."Last Statement No_",@4) AS "Last Statement No_",ISNULL("Customer"."Print Statements",@6) AS "Print Statements",ISNULL("Customer"."Bill-to Customer No_",@1) AS "Bill-to Customer No_",ISNULL("Customer"."Priority",@4) AS "Priority",ISNULL("Customer"."Payment Method Code",@1) AS "Payment Method Code",ISNULL("Customer"."Last Date Modified",@7) AS "Last Date Modified",ISNULL("Customer"."Application Method",@5) AS "Application Method",ISNULL("Customer"."Prices Including VAT",@6) AS "Prices Including VAT",ISNULL("Customer"."Location Code",@1) AS "Location Code",ISNULL("Customer"."Fax No_",@2) AS "Fax No_",ISNULL("Customer"."Telex Answer Back",@2) AS "Telex Answer Back",ISNULL("Customer"."VAT Registration No_",@2) AS "VAT Registration No_",ISNULL("Customer"."Combine Shipments",@6) AS "Combine Shipments",ISNULL("Customer"."Gen_ Bus_ Posting Group",@1) AS "Gen_ Bus_ Posting Group",DATALENGTH("Customer"."Picture") AS "Picture",ISNULL("Customer"."Post Code",@1) AS "Post Code",ISNULL("Customer"."County",@2) AS "County",ISNULL("Customer"."E-Mail",@2) AS "E-Mail",ISNULL("Customer"."Home Page",@2) AS "Home Page",ISNULL("Customer"."Reminder Terms Code",@1) AS "Reminder Terms Code",ISNULL("Customer"."No_ Series",@1) AS "No_ Series",ISNULL("Customer"."Tax Area Code",@1) AS "Tax Area Code",ISNULL("Customer"."Tax Liable",@6) AS "Tax Liable",ISNULL("Customer"."VAT Bus_ Posting Group",@1) AS "VAT Bus_ Posting Group",ISNULL("Customer"."Reserve",@5) AS "Reserve",ISNULL("Customer"."Block Payment Tolerance",@6) AS "Block Payment Tolerance",ISNULL("Customer"."IC Partner Code",@1) AS "IC Partner Code",ISNULL("Customer"."Prepayment _",@3) AS "Prepayment _",ISNULL("Customer"."Partner Type",@5) AS "Partner Type",ISNULL("Customer"."Preferred Bank Account",@1) AS "Preferred Bank 
Account",ISNULL("Customer"."Cash Flow Payment Terms Code",@1) AS "Cash Flow Payment Terms Code",ISNULL("Customer"."Primary Contact No_",@1) AS "Primary Contact 
No_",ISNULL("Customer"."Responsibility Center",@1) AS "Responsibility Center",ISNULL("Customer"."Shipping Advice",@5) AS "Shipping Advice",ISNULL("Customer"."Shipping Time",@8) AS "Shipping 
Time",ISNULL("Customer"."Shipping Agent Service Code",@1) AS "Shipping Agent Service Code",ISNULL("Customer"."Service Zone Code",@1) AS "Service Zone Code",ISNULL("Customer"."Allow Line 
Disc_",@6) AS "Allow Line Disc_",ISNULL("Customer"."Base Calendar Code",@1) AS "Base Calendar Code",ISNULL("Customer"."Copy Sell-to Addr_ to Qte From",@5) AS "Copy Sell-to Addr_ to Qte 
From",ISNULL("Customer"."UPS Zone",@1) AS "UPS Zone",ISNULL("Customer"."Tax Exemption No_",@2) AS "Tax Exemption No_",ISNULL("Customer"."Bank Communication",@5) AS "Bank 
Communication",ISNULL("Customer"."Check Date Format",@5) AS "Check Date Format",ISNULL("Customer"."Check Date Separator",@5) AS "Check Date Separator",ISNULL("Customer"."RFC No_",@1) AS "RFC 
No_",ISNULL("Customer"."CURP No_",@1) AS "CURP No_",ISNULL("Customer"."State Inscription",@2) AS "State Inscription",ISNULL("Customer"."Tax Identification Type",@5) AS "Tax Identification 
Type",ISNULL("Customer"."Shipping Agent Code 2",@1) AS "Shipping Agent Code 2",ISNULL("Customer"."Default Ship-to Address",@1) AS "Default Ship-to Address",ISNULL("Customer"."Print Invoice 
Net Price",@6) AS "Print Invoice Net Price",ISNULL("Customer"."Statistical Area",@1) AS "Statistical Area",ISNULL("Customer"."Packing Charge _",@3) AS "Packing Charge 
_",ISNULL("Customer"."Linked Vendor No_",@1) AS "Linked Vendor No_",ISNULL("Customer"."Payment Bank Account",@1) AS "Payment Bank Account",ISNULL("Customer"."OurCustCode",@2) AS 
"OurCustCode",ISNULL("Customer"."InvPeriod",@5) AS "InvPeriod",ISNULL("Customer"."Add Tariff Info in Invoice",@6) AS "Add Tariff Info in Invoice",ISNULL("Customer"."PackingExcel",@6) AS "PackingExcel",ISNULL("Customer"."Web Order View",@6) AS "Web Order View",ISNULL("Customer"."Bill-To Contact No_",@1) AS "Bill-To Contact No_",ISNULL("Customer"."Internal Customer Code",@1) AS "Internal Customer Code",ISNULL("Customer"."CreationDate",@7) AS "CreationDate",ISNULL("Customer"."Conformity Certificate Request",@6) AS "Conformity Certificate Request",ISNULL("Customer"."Web Order View SD",@6) AS "Web Order View SD",ISNULL("Customer"."Bin Code Customer Defaut",@1) AS "Bin Code Customer Defaut",ISNULL("Customer"."Overthickness Discounts",@3) AS "Overthickness Discounts",ISNULL("SUB$Balance (LCY)"."Balance (LCY)$Detailed Cust_ Ledg_ Entry$SUM$Amount (LCY)",@3) AS "Balance (LCY)",ISNULL("SUB$Outstanding Orders (LCY)"."Outstanding Orders (LCY)$Sales Line$SUM$Outstanding Amount (LCY)",@3) AS "Outstanding Orders (LCY)",ISNULL("SUB$Shipped Not Invoiced (LCY)"."Shipped Not Invoiced (LCY)$Sales Line$SUM$Shipped Not Invoiced (LCY)",@3) AS "Shipped Not Invoiced (LCY)",ISNULL("SUB$Outstanding Invoices (LCY)"."Outstanding Invoices (LCY)$Sales Line$SUM$Outstanding Amount (LCY)",@3) AS "Outstanding Invoices (LCY)",ISNULL("SUB$Outstanding Serv_ Orders (LCY)"."Outstanding Serv_ Orders (LCY)$Service Line$SUM$Outstanding Amount (LCY)",@3) AS "Outstanding Serv_ Orders (LCY)",ISNULL("SUB$Serv Shipped Not Invoiced(LCY)"."Serv Shipped Not Invoiced(LCY)$Service Line$SUM$Shipped Not Invoiced (LCY)",@3) AS "Serv Shipped Not Invoiced(LCY)",ISNULL("SUB$Outstanding Serv_Invoices(LCY)"."Outstanding Serv_Invoices(LCY)$Service Line$SUM$Outstanding Amount (LCY)",@3) AS "Outstanding Serv_Invoices(LCY)" 
FROM "Jason Industries Database NAV (8-0)".dbo."MegaUSATest$Customer" AS "Customer" WITH(READUNCOMMITTED)  OUTER APPLY (SELECT TOP (1) ISNULL(SUM("Balance (LCY)$Detailed Cust_ Ledg_ Entry"."SUM$Amount (LCY)"),@3) AS "Balance (LCY)$Detailed Cust_ Ledg_ Entry$SUM$Amount (LCY)" FROM "Jason Industries Database NAV (8-0)".dbo."MegaUSATest$Detailed Cust_ Ledg_ Entry$VSIFT$5" AS "Balance 
(LCY)$Detailed Cust_ Ledg_ Entry" WITH(READUNCOMMITTED,NOEXPAND)  WHERE ("Balance (LCY)$Detailed Cust_ Ledg_ Entry"."Customer No_"="Customer"."No_")) AS "SUB$Balance (LCY)"  OUTER APPLY 
(SELECT TOP (1) ISNULL(SUM("Outstanding Orders (LCY)$Sales Line"."SUM$Outstanding Amount (LCY)"),@3) AS "Outstanding Orders (LCY)$Sales Line$SUM$Outstanding Amount (LCY)" FROM "Jason 
Industries Database NAV (8-0)".dbo."MegaUSATest$Sales Line$VSIFT$3" AS "Outstanding Orders (LCY)$Sales Line" WITH(READUNCOMMITTED,NOEXPAND)  WHERE (ISNULL("Outstanding Orders (LCY)$Sales 
Line"."Document Type",@5)=@9 AND "Outstanding Orders (LCY)$Sales Line"."Bill-to Customer No_"="Customer"."No_")) AS "SUB$Outstanding Orders (LCY)"  OUTER APPLY (SELECT TOP (1) 
ISNULL(SUM("Shipped Not Invoiced (LCY)$Sales Line"."SUM$Shipped Not Invoiced (LCY)"),@3) AS "Shipped Not Invoiced (LCY)$Sales Line$SUM$Shipped Not Invoiced (LCY)" FROM "Jason Industries 
Database NAV (8-0)".dbo."MegaUSATest$Sales Line$VSIFT$3" AS "Shipped Not Invoiced (LCY)$Sales Line" WITH(READUNCOMMITTED,NOEXPAND)  WHERE (ISNULL("Shipped Not Invoiced (LCY)$Sales 
Line"."Document Type",@5)=@10 AND "Shipped Not Invoiced (LCY)$Sales Line"."Bill-to Customer No_"="Customer"."No_")) AS "SUB$Shipped Not Invoiced (LCY)"  OUTER APPLY (SELECT TOP (1) 
ISNULL(SUM("Outstanding Invoices (LCY)$Sales Line"."SUM$Outstanding Amount (LCY)"),@3) AS "Outstanding Invoices (LCY)$Sales Line$SUM$Outstanding Amount (LCY)" FROM "Jason Industries Database 
NAV (8-0)".dbo."MegaUSATest$Sales Line$VSIFT$3" AS "Outstanding Invoices (LCY)$Sales Line" WITH(READUNCOMMITTED,NOEXPAND)  WHERE (ISNULL("Outstanding Invoices (LCY)$Sales Line"."Document 
Type",@5)=@11 AND "Outstanding Invoices (LCY)$Sales Line"."Bill-to Customer No_"="Customer"."No_")) AS "SUB$Outstanding Invoices (LCY)"  OUTER APPLY (SELECT TOP (1) ISNULL(SUM("Outstanding 
Serv_ Orders (LCY)$Service Line"."SUM$Outstanding Amount (LCY)"),@3) AS "Outstanding Serv_ Orders (LCY)$Service Line$SUM$Outstanding Amount (LCY)" FROM "Jason Industries Database NAV 
(8-0)".dbo."MegaUSATest$Service Line$VSIFT$3" AS "Outstanding Serv_ Orders (LCY)$Service Line" WITH(READUNCOMMITTED,NOEXPAND)  
WHERE (ISNULL("Outstanding Serv_ Orders (LCY)$Service Line"."Document Type",@5)=@12 AND "Outstanding Serv_ Orders (LCY)$Service Line"."Bill-to Customer No_"="Customer"."No_")) 
AS "SUB$Outstanding Serv_ Orders (LCY)"  
OUTER APPLY (SELECT TOP (1) ISNULL(SUM("Serv Shipped Not Invoiced(LCY)$Service Line"."SUM$Shipped Not Invoiced (LCY)"),@3) 
AS "Serv Shipped Not Invoiced(LCY)$Service Line$SUM$Shipped Not Invoiced (LCY)" 
FROM "Jason Industries Database NAV (8-0)".dbo."MegaUSATest$Service Line$VSIFT$3" AS "Serv Shipped Not Invoiced(LCY)$Service Line" 
WITH(READUNCOMMITTED,NOEXPAND)  WHERE (ISNULL("Serv Shipped Not Invoiced(LCY)$Service Line"."Document Type",@5)=@13 
AND "Serv Shipped Not Invoiced(LCY)$Service Line"."Bill-to Customer No_"="Customer"."No_")) AS "SUB$Serv Shipped Not Invoiced(LCY)"  
OUTER APPLY (SELECT TOP (1) ISNULL(SUM("Outstanding Serv_Invoices(LCY)$Service Line"."SUM$Outstanding Amount (LCY)"),@3) 
AS "Outstanding Serv_Invoices(LCY)$Service Line$SUM$Outstanding Amount (LCY)" FROM "Jason Industries Database NAV (8-0)".dbo."MegaUSATest$Service Line$VSIFT$3" 
AS "Outstanding Serv_Invoices(LCY)$Service Line" WITH(READUNCOMMITTED,NOEXPAND)  WHERE (ISNULL("Outstanding Serv_Invoices(LCY)$Service Line"."Document Type",@5)=@14 
AND "Outstanding Serv_Invoices(LCY)$Service Line"."Bill-to Customer No_"="Customer"."No_")) AS "SUB$Outstanding Serv_Invoices(LCY)"  ORDER BY "No_" DESC OPTION(OPTIMIZE FOR UNKNOWN, FAST 50)'
,N'@0 binary(8),@1 nvarchar(20),@2 nvarchar(20),@3 decimal(38,20),@4 int,@5 int,@6 tinyint,@7 datetime,@8 varchar(32),@9 int,@10 int,@11 int,@12 int,@13 int,@14 int',@0=0x0000000000000000,@1=N'',@2=N'',@3=0,@4=0,@5=0,@6=0,@7='1753-01-01 00:00:00',@8='',@9=1,@10=1,@11=2,@12=1,@13=1,@14=2


!Bad SQL   !------------------------


!---------------------------------------------------------------------------
Window WINDOW('Fix SQL v2.0'),AT(,,423,282),FONT('MS Sans Serif',8,,FONT:regular),IMM,ICON('Rreplace.ico'), |
         SYSTEM,GRAY,AUTO
       SHEET,AT(7,3,411,257),USE(?Sheet1)
         TAB('&1 - New Clipboard'),USE(?TabOut)
           PROMPT(''),AT(9,24,405,235),USE(?CLipOutText),SCROLL
         END
         TAB('&2 - Original Clipboard'),USE(?TabIn)
           PROMPT(''),AT(9,24,405,235),USE(?CLipInText),SCROLL
         END
         TAB('&3 - Edit'),USE(?TabEdit),HIDE
           TEXT,AT(9,24,405,235),USE(ClipOut),BOXED
         END
       END
       BUTTON('&Fix Clipboard'),AT(9,265,81,14),USE(?ButtonGet),LEFT,ICON('PASTE.ICO')
       BUTTON('&Set Clipboard'),AT(171,265,81,14),USE(?ButtonSet),HIDE,LEFT,ICON('CUT.ICO')
       BUTTON('&Reset Clipboard'),AT(171,265,81,14),USE(?ButtonReset),LEFT,ICON('CUT.ICO')
       BUTTON('E&xit'),AT(375,265,43,14),USE(?CancelButton),LEFT,ICON('Close.ico')
     END
!---------------------------------------------------------------------------
  CODE
!---------------------------------------------------------------------------
  Open(Window)
  Post(Event:Accepted, ?ButtonGet)
  Accept
    CASE EVENT()
    OF EVENT:GainFocus
       If LastTime = 0
          LastTime = Clock()
       ElsIf Abs(LastTime - Clock()) > e_Threshold
          CASE Message('Fix Clipboard for SQL?', 'Fix?',  Icon:Question,Button:Yes+Button:No+Button:Cancel, Button:OK ,0)
          Of Button:Yes        !&Yes
             LastTime = Clock()
             Post(Event:Accepted, ?ButtonGet)
          Of Button:Cancel        !&Yes
             Post(Event:CloseDown)
          !Of Button:No        !&No
          End
       End
    END!Case
    CASE ACCEPTED()
    OF ?ButtonGet
      ClipIn = ClipBoard()
      If ClipIn = ''
        ClipIn = 'Clipboard is Empty!'
      End
      ?CLipInText{Prop:Text} = ClipIn
      Do FixClip
      DISPLAY()
      ?CLipOutText{Prop:Text} = ClipOut
      SetClipBoard(ClipOut)

    OF ?ButtonSet
      SetClipBoard(ClipOut)
      ?CLipOutText{Prop:Text} = ClipOut

    OF ?ButtonReset
      ClipOut = ClipIn
      SetClipBoard(ClipOut)
      ?CLipOutText{Prop:Text} = ClipOut

    OF ?CancelButton
       BREAK
    END
  End
  Close(Window)
  RETURN

!---------------------------------------------------------------------------
FixClip Routine
!---------------------------------------------------------------------------
 Data
LastQuote       Byte(False)
 Code
!---------------------------------------------------------------------------
  ClipOut = ClipIn
  MaxLen = Len(Clip(ClipOut))
  If MaxLen < 8
     Message('Nothing to Fix')
     Exit
  End

!If present Trim the crap
  ThisLen = Instring( 'N<39>SELECT', UPPER(ClipOut), 1, 1)
  If ThisLen
     DO FindParms
  Else
     ThisLen = Instring( 'N<39>INSERT', UPPER(ClipOut), 1, 1)
     If ThisLen
        DO FindParms
     Else
        ThisLen = Instring( 'N<39>DELETE', UPPER(ClipOut), 1, 1)
        If ThisLen
           DO FindParms
        Else
           ThisLen = Instring( 'N<39>UPDATE', UPPER(ClipOut), 1, 1)
           If ThisLen
              DO FindParms
           End
        End
     End
  End
  Free(ParmQ)
  Clear(ParmQ)
  If Instring('@P', UPPER(ClipOut),1,1)        !JM 05/08/15
     Do FixParmQ
  ElsIf Instring('@', UPPER(ClipOut),1,1)          !JM 05/08/15
     Do FixParmQNew
  End
!  SetClipBoard(Clip(clipout))
!  Message('aclipout inclip=' & clipout)

!Change '' to '
  Loop ThisLen = MaxLen to 1 by -1
    If ClipOut[ThisLen] = '<39>'
      If LastQuote = True
         If MaxLen > ThisLen + 1
            ClipOut = ClipOut[1 : ThisLen] & ClipOut[ThisLen+2 : MaxLen]
         Else
            ClipOut = ClipOut[1 : ThisLen]
         End
         MaxLen -= 1
         LastQuote = False
      Else
         LastQuote = True
      End
    Else
      LastQuote = False
    End
  End!Loop

  !Force a LF at certain keywords.
  SearchFor = ' ORDER BY '
  Do ADDCR

  SearchFor = ' OUTER APPLY '
  Do ADDCR

  SearchFor = ' WHERE '
  Do ADDCR

  SearchFor = ' FROM '
  Do ADDCR

  SearchFor = ' LEFT OUTER JOIN '
  Do ADDCR

  !Look for logical line breaks to shorten up the code lines
  MaxLen = Len(Clip(ClipOut))
  SearchFor = ', '
  SearchLenLess1 = 1
  Do ADDLFBACK

  SearchFor = ','
  SearchLenLess1 = 0
  Do ADDLFBACK

  SearchFor = ' OR '
  SearchLenLess1 = 3
  Do ADDLFBACK

  SearchFor = ' AND '
  SearchLenLess1 = 4
  Do ADDLFBACK

  SearchFor = ' '          !JM 05/08/15
  SearchLenLess1 = 0       !JM 05/08/15
  Do ADDLFBACK             !JM 05/08/15

  !Insert the parameters into the code
  If Records(ParmQ)
     Do FixParms
  End                      
  DO RemoveExtraCR
  EXIT

!---------------------------------------------------------------------------
FindParms  Routine
!ThisLen = the pointer to N'whatever
!---------------------------------------------------------------------------
  ClipOut = ClipOut[ThisLen+2 : MaxLen]
  MaxLen = Len(Clip(ClipOut))
  Loop ThisLen = 1 to MaxLen
    If ClipOut[ThisLen] = '<39>'
       If ThisLen < MaxLen
          If ClipOut[ThisLen+1] = '<39>'
             ThisLen += 1  !The cycle will add another one so that paired quotes are ignored
             Cycle
          End
          ParmIN = ClipOut[ThisLen+1 : MaxLen] & '<0>'
       End
       ClipOut = ClipOut[1 : ThisLen-1]
       Break
    End
  End!Loop
!---------------------------------------------------------------------------
FixParmQ    Routine
  Data
ParmLen     Long
InParm          Byte(0)
OneMoreParm     BYTE            !MW 05/20/11
  Code
!---------------------------------------------------------------------------
  ParmLen = Len(ParmIN )
  ThisLen = 1
  InParm = True
  Inquote = False
  If DebugOn
     SETCLIPBOARD(ParmIN)
     Message('ParmIn Clip','Look in Clipboard')
  End
  Loop
                
    Case ParmIN[ThisLen]
    OF ','
        OneMoreParm = TRUE      !mw 05/20/11
        If Inquote
          !Next
        ElsIf Not InParm and ThisLen > 1
            PQ:ParmNo = Records(ParmQ) + 1
            PQ:MyParm = ParmIn[1 : ThisLen-1] & '<0>'
            Add(ParmQ)
              If DebugOn
                 SETCLIPBOARD(PQ:MyParm)
                 Message('Parm ' & Records(ParmQ) & ' in Clip','1')
              End
            If Errorcode() Then Stop('Add Q:' & Error()).
            If ThisLen < ParmLen
                ParmIN = ParmIn[ThisLen+1 : ParmLen] & '<0>'
                ParmLen -= ThisLen
                ThisLen = 1
                Cycle
            Else
                Break
            End
        ElsIf ThisLen < ParmLen
            InParm = False
            ParmIN = ParmIn[ThisLen+1 : ParmLen]  & '<0>'
            ParmLen -= ThisLen
            ThisLen = 1
            Cycle
        End
    OF '<39>'
       Inquote = 1 - Inquote
    OF '@'
       If not Inquote
          InParm = True
       End
    OF '<10>'
    OROF '<13>'
       If Not InQuote and not INPARM
          PQ:MyParm = ParmIn[1 : ThisLen-1] & '<0>'
          PQ:ParmNo = Records(ParmQ) + 1
          Add(ParmQ)
          If Errorcode() Then Stop('Add Q:' & Error()).
              If DebugOn
                 SETCLIPBOARD(PQ:MyParm)
                 Message('Parm ' & Records(ParmQ) & ' in Clip','2')
              End
          Break
        End
	!MW 05/20/11 Below
    OF ' '
        if InQuote 
            !do nothing
        Elsif InParm       !JM 01/02/15
            !do nothing
        ELSE
            IF OneMoreParm      !MW - catch unquoted last parm - !mw 05/20/11
                PQ:MyParm = ParmIn[1 : ThisLen] & '<0>'
                PQ:ParmNo = Records(ParmQ) + 1
                Add(ParmQ)
                If Errorcode() Then Stop('Add Q:' & Error()).
                    If DebugOn
                       SETCLIPBOARD(PQ:MyParm)
                       Message('Parm ' & Records(ParmQ) & ' in Clip','3')
                    End

                ParmIN = ParmIn[ThisLen+1 : ParmLen]  & '<0>'
                ParmLen -= ThisLen
                ThisLen = 1
                OneMoreParm = false
                Cycle
            END
        END
	!MW 05/20/11 Above

    END !Case
    ThisLen += 1
    If ThisLen > ParmLen Then Break.
  END!Loop
!  Message('In Q = ' & Records(ParmQ))
!---------------------------------------------------------------------------
FixParmQNew    Routine
  Data
ParmLen     Long
InParm2         Byte(0)
InParmPrefix    Byte(0)
FoundOne        Byte(0)
OneMoreParm     BYTE            !MW 05/20/11
ParmString      CSTRING(4)
  Code
!---------------------------------------------------------------------------
  ParmLen = Len(ParmIN )
  ThisLen = 1
  InParm2 = True
  InParmPrefix = False
  Inquote = False
  If DebugOn
     SETCLIPBOARD(ParmIN)
     Message('ParmIn Clip','Look in Clipboard')
  End
  Loop
                
    If InParmPrefix
       Case ParmIN[ThisLen]
       OF '='      
          InParmPrefix = False
          If ThisLen < ParmLen 
             IF ParmIN[ThisLen+1] = 'N'
                ThisLen += 1
             END
             ParmIN = ParmIn[ThisLen+1 : ParmLen] & '<0>'
             ParmLen -= ThisLen
             ThisLen = 1
          END
       OF   '0'    
       OROF '1'    
       OROF '2'    
       OROF '3'    
       OROF '4'    
       OROF '5'    
       OROF '6'    
       OROF '7'    
       OROF '8'    
       OROF '9'    
          ParmString = ParmString & ParmIN[ThisLen]
       ELSE
          ThisLen += 1
          If ThisLen > ParmLen Then Break.
          CYCLE
       END!Case
    END
    Case ParmIN[ThisLen]
    OF ','
        OneMoreParm = TRUE      !mw 05/20/11
        If Inquote
          !Next
        ElsIf Not InParm2 and ThisLen > 1 AND FoundOne 
            PQ:MyParm = ParmIn[1 : ThisLen-1] & '<0>'
            PQ:ParmNo = ParmString
            Add(ParmQ)
              If DebugOn
                 SETCLIPBOARD(PQ:MyParm)
                 Message('Parm ' & Records(ParmQ) & '/' & ThisLen & ' in Clip. OK?','1A')
              End
            If Errorcode() Then Stop('Add Q:' & Error()).
            If ThisLen < ParmLen
                ParmIN = ParmIn[ThisLen+1 : ParmLen] & '<0>'
                ParmLen -= ThisLen
                ThisLen = 1
                Cycle
            Else
                Break
            End
        ElsIf ThisLen < ParmLen
            InParm2 = False
            ParmIN = ParmIn[ThisLen+1 : ParmLen]  & '<0>'
            ParmLen -= ThisLen
            ThisLen = 1
            Cycle
        End
    OF '<39>'
       Inquote = 1 - Inquote
    OF '@'
       If not Inquote
          InParmPrefix = True
          ParmString   = ''
          FoundOne = True
       End
    OF '<10>'
    OROF '<13>'
       If Not InQuote and not INPARM2
          PQ:MyParm = ParmIn[1 : ThisLen-1] & '<0>'
          PQ:ParmNo = ParmString
          Add(ParmQ)
          If Errorcode() Then Stop('Add Q:' & Error()).
              If DebugOn
                 SETCLIPBOARD(PQ:MyParm)
                 Message('Parm ' & Records(ParmQ) & ' in Clip','2a')
              End
          Break
        End
	!MW 05/20/11 Below
    OF ' '
        if InQuote 
            !do nothing
        Elsif InParm2       !JM 01/02/15
            !do nothing
        ELSE
            IF OneMoreParm      !MW - catch unquoted last parm - !mw 05/20/11
                PQ:MyParm = ParmIn[1 : ThisLen] & '<0>'
                PQ:ParmNo = ParmString
                Add(ParmQ)
                If Errorcode() Then Stop('Add Q:' & Error()).
                    If DebugOn
                       SETCLIPBOARD(PQ:MyParm)
                       Message('Parm ' & Records(ParmQ) & ' in Clip','3a')
                    End

                ParmIN = ParmIn[ThisLen+1 : ParmLen]  & '<0>'
                ParmLen -= ThisLen
                ThisLen = 1
                OneMoreParm = false
                Cycle
            END
        END
    END !Case
    If ThisLen = ParmLen 
       IF OneMoreParm      !MW - catch unquoted last parm - !mw 05/20/11
          PQ:MyParm = ParmIn[1 : ThisLen] & '<0>'
          PQ:ParmNo = ParmString
          Add(ParmQ)
          If Errorcode() Then Stop('Add Q:' & Error()).
              If DebugOn
                 SETCLIPBOARD(PQ:MyParm)
                 Message('Parm ' & Records(ParmQ) & ' in Clip','4a')
              End
       END
    END
    ThisLen += 1
    If ThisLen > ParmLen Then Break.
  END!Loop
!  Message('In Q = ' & Records(ParmQ))
!---------------------------------------------------------------------------
ADDCR   Routine
!---------------------------------------------------------------------------

  Loop 30 Times
     ThisLen = Instring( SearchFor, UPPER(ClipOut), 1, 1)
     If ThisLen
        ClipOut = ClipOut[1 : ThisLen-1] & e_LF & ClipOut[ThisLen+1 : MaxLen]
     Else
        Break
     End
  End

!---------------------------------------------------------------------------
ADDLFBACK   Routine
 Data
CurPos      Long
 Code
!---------------------------------------------------------------------------

  CurPos = 0
  ThisLen = MaxLen + 1
  Inquote = False
  InDblQuote = False
  InBracket  = False
  InParens = False

  Loop
    ThisLen -= 1
    If ThisLen = 0 Then Break.
    If ClipOut[ThisLen] = e_LF and NOT InQuote AND NOT InDblQuote
       CurPos = 0
       Cycle
    End
    CurPos += 1
    If ClipOut[ThisLen] = '<39>'
       Inquote = 1 - Inquote
    End
    If Inquote then cycle.
    If ClipOut[ThisLen] = '"'
       InDblQuote = 1 - InDblQuote
    End
    IF InDblQuote then cycle.
    If ClipOut[ThisLen] = ']'
       InBracket = True
    ElsIf ClipOut[ThisLen] = '[' AND InBracket
       InBracket = False
    End
    IF InBracket  then cycle.
    If ClipOut[ThisLen] = ')'
       InParens += 1
    ElsIf ClipOut[ThisLen] = '(' AND InParens
       InParens  -= 1
    End                      
    IF InParens AND (SearchFor = ',' OR SearchFor = ' ')
       CYCLE
    END
    If CurPos < e_MaxLine then Cycle.

    If UPPER(ClipOut[ThisLen : ThisLen+SearchLenLess1]) = SearchFor
       If ThisLen > 2
          If ClipOut[ThisLen-2 : ThisLen-1 ] = e_LFTab
             CurPos = 0
             Cycle
          End
       End
       ClipOut = ClipOut[1 : ThisLen-1] & e_LFTab & ClipOut[ThisLen : MaxLen]
       MaxLen += 2
       If MaxLen > E_MaxOut then Break.
       CurPos = 0
    End
  End!Loop

!---------------------------------------------------------------------------
RemoveExtraCR  Routine
 DATA
FixCnt   Long
 CODE
!---------------------------------------------------------------------------
  MaxLen = Len(Clip(ClipOut))
  ThisLen = 0
  Loop
    ThisLen += 1
    If ThisLen >= MaxLen Then Break.

    If ClipOut[ThisLen] = e_CR                    |
     AND  (InQuote OR InDblQuote OR InBracket)
       ClipOut = ClipOut[1 : ThisLen-1] & ClipOut[ThisLen+1 : MaxLen]
       ThisLen -= 1
       MaxLen -= 1
       FixCnt += 1
       CYCLE
    End
    If ClipOut[ThisLen] = e_LF                     |
     AND  (InQuote OR InDblQuote OR InBracket)
       ClipOut = ClipOut[1 : ThisLen-1] & ClipOut[ThisLen+1 : MaxLen]
       ThisLen -= 1
       MaxLen -= 1
       FixCnt += 1
       CYCLE
    End
    If ClipOut[ThisLen] = '<39>'
       Inquote = 1 - Inquote
    End
    If Inquote then cycle.

    If ClipOut[ThisLen] = '"'
       InDblQuote = 1 - InDblQuote
    End
    IF InDblQuote then cycle.

    If ClipOut[ThisLen] = '['
       InBracket = True
    ElsIf ClipOut[ThisLen] = ']' AND InBracket
       InBracket = False
    End
    IF InBracket  then cycle.
  End!Loop
  !MESSAGE('FixCnt=' &  FixCnt)

!---------------------------------------------------------------------------
FixParms   Routine
 Data
MyPointer   Long
MyLen       Long
Subs        Long
MyChar      STRING(1)
 Code
!---------------------------------------------------------------------------

  ThisLen = MaxLen - 1
  Inquote = False
  MaxLen = Len(Clip(ClipOut))
  SORT(ParmQ, PQ:ParmNo)

  Loop
    ThisLen -= 1
    If ThisLen = 0 Then Break.
    If UPPER(ClipOut[ThisLen]) = '@'      !JM 05/08/15
       If UPPER(ClipOut[ThisLen+1]) = 'P'     !JM 05/08/15
          MyLen = 2
       ELSE
          MyLen = 1        !JM 05/08/15
       END
       If ClipOut[ThisLen+MyLen] >= '0' AND ClipOut[ThisLen+MyLen] <= '9'
          MyChar = ClipOut[ThisLen+MyLen]
          MyPointer = MyChar
          If ThisLen+3 <= MaxLen AND ClipOut[ThisLen+MyLen+1] >= '0' AND ClipOut[ThisLen+MyLen+1] <= '9'
             MyPointer = (MyPointer * 10) + ClipOut[ThisLen+MyLen+1]
             MyLen += 2
          ELSE
             MyLen += 1
          End
          If MyPointer = 0 AND MyChar <> '0' then Cycle.

          PQ:ParmNo = MyPointer
          Get(ParmQ, PQ:ParmNo)
          If Errorcode() Then Stop('Error on Get Q Pointer:' & MyPointer & '/' & Error()).
              If DebugOn
                 SETCLIPBOARD(PQ:MyParm)
                 Message('Getting Parm ' & MyPointer & ' in Clip')
              End
          ClipOut = ClipOut[1 : ThisLen-1] & PQ:MyParm & ClipOut[ThisLen+MyLen : MaxLen]
          MaxLen = Len(Clip(ClipOut))
          Subs += 1
       Else
          Cycle
       End
    End
  End!Loop
! Message('Subs = ' & Subs)
